#python

"""
ImageLinearizer.py

Created by Philip Lawson on 2009-08-09.
Copyright (c) 2009 Philip Lawson. All rights reserved.
"""
lx.out("Script is starting.")

#Queries how many renderouts there are in the scene
outputNum = lx.eval("query sceneservice renderOutput.n ?")

#A loop that will cycle through the outputs and break when it finds the final color output
i=0 #Counter

lx.out("Starting Loop") #Loop Start text

#Loop
while i < outputNum:
	#Check to see what the current renderout name is
	renderName = lx.eval("query sceneservice renderOutput.name ? %d"  %i)
	if renderName == "Final Color Output": #if its final color output then...
		outputID = lx.eval("query sceneservice renderOutput.id ? %d" %i) #get the outputs id
		lx.out(outputID) #print the id
		#select the final color output
		lx.eval("select.subItem %s set textureLayer;render;environment;light;camera;mediaClip;txtrLocator" % outputID)
		#Queries the gamma value and stores it in a variable called renderGamam
		renderGamma = lx.eval("item.channel renderOutput$gamma ?")
		lx.out(renderGamma) #prints the gamma value
		lx.out("Got Gamma") #prints the gamma has been aquired
		break #breaks the loop
	else:
		i=i+1 #adds one to the count
		lx.out("On pass %s" %i)	 #prints the current pass

lx.out("Loop Complete") #Loop complete print out
i=0 #resets the coounter for future use

#Checks to see the total number of image textures in the scene and stores it in imageNum
imageNum = lx.eval("query sceneservice imageMap.N ?");

#Gamma correction
gammaCorrection = 1/renderGamma

#A loop that cycles through all the images in the scene and corrects their gamma (1/scene gamma)
while i < imageNum:
	imageID = lx.eval("query sceneservice imageMap.id ? %d" %i) #Collects the image ID
	lx.eval("select.subItem %s set textureLayer;render;environment;light;camera" %imageID) #Selects the image based on id order
	mapType = lx.eval("shader.setEffect ?") #Checks to see the effect type of the image
	if mapType == "diffColor" or mapType == "lumiColor" or mapType == "reflColor" or mapType == "specColor" or mapType == "subsColor" or mapType == "tranColor": #If its one of the options correct it otherwise forget it
		lx.eval("item.channel imageMap$gamma %s" %gammaCorrection)
		i=i+1
		lx.out("Image %s corrected" %imageID)
	else:
		i=i+1

lx.out("Script Complete.")
